function varargout = grafici(varargin)
% GRAFICI MATLAB code for grafici.fig
%      GRAFICI, by itself, creates a new GRAFICI or raises the existing
%      singleton*.
%
%      H = GRAFICI returns the handle to a new GRAFICI or the handle to
%      the existing singleton*.
%
%      GRAFICI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GRAFICI.M with the given input arguments.
%
%      GRAFICI('Property','Value',...) creates a new GRAFICI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before grafici_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to grafici_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help grafici

% Last Modified by GUIDE v2.5 12-Dec-2018 14:31:49

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @grafici_OpeningFcn, ...
                   'gui_OutputFcn',  @grafici_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before grafici is made visible.
function grafici_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to grafici (see VARARGIN)

% Choose default command line output for grafici
handles.output = hObject;
set(hObject,'toolbar','figure');
stato_release=evalin('base','stato_release');
stato_burn=evalin('base','stato_burn');
stato_coast=evalin('base','stato_coast');


axes(handles.axes1)
plot3(stato_release(:,1),zeros(length(stato_release),1),stato_release(:,2))
hold on
plot3(stato_burn(:,1),zeros(length(stato_burn),1),stato_burn(:,2))
plot3(stato_coast(:,1),zeros(length(stato_coast),1),stato_coast(:,2))
grid on
xlabel('ground track')
ylabel('altitude')
title('Trajectory')
stato_tot=[stato_release;stato_burn(2:end,:);stato_coast(2:end,:)]; %perch i valori iniziali sono uguali a quelli finali della fase precedente
[ymax,ind_ymax]=max(stato_tot(:,2));
assignin('base','apogee',ymax);
ymax=ymax/1000; %km
plot3(stato_tot(ind_ymax,1),0,stato_tot(ind_ymax,2),'-mo',...
    'LineWidth',1,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[.49 1 .63],...
    'MarkerSize',6)
legend('release','burn','coast','apogee','Location','northwest')
txt = ['Apogee at ' num2str(ymax) ' km'];
text(stato_tot(ind_ymax,1)+1000,0,stato_tot(ind_ymax,2),txt)


axes(handles.axes2)
t_release=evalin('base','t_release');
t_burn=evalin('base','t_burn');
t_coast=evalin('base','t_coast');
t=[t_release t_burn t_coast];
plot(t_release,stato_release(:,1))
hold on
plot(t_burn,stato_burn(:,1))
plot(t_coast,stato_coast(:,1))
xlabel('time')
ylabel('ground track')
title('ground track vs time')
legend('release','burn','coast','Location','southeast')
grid on


axes(handles.axes3)
plot(t_release,stato_release(:,2))
hold on
plot(t_burn,stato_burn(:,2))
plot(t_coast,stato_coast(:,2))
xlabel('time')
ylabel('altitude')
title('altitude vs time')
legend('release','burn','coast','Location','northeast')
grid on

axes(handles.axes4)
plot(t_release,sqrt(stato_release(:,3).^2+stato_release(:,4).^2))
hold on

plot(t_burn,sqrt(stato_burn(:,3).^2+stato_burn(:,4).^2))
plot(t_coast,sqrt(stato_coast(:,3).^2+stato_coast(:,4).^2))
xlabel('time')
ylabel('velocity')
title('velocity vs time')
legend('release','burn','coast','Location','north')
grid on

axes(handles.axes5)
plot(t_release,stato_release(:,3))
hold on

plot(t_burn,stato_burn(:,3))
plot(t_coast,stato_coast(:,3))
xlabel('time')
ylabel('horizontal velocity')
title('horizontal velocity vs time')
legend('release','burn','coast','Location','north')
grid on

axes(handles.axes6)
plot(t_release,stato_release(:,4))
hold on

plot(t_burn,stato_burn(:,4))
plot(t_coast,stato_coast(:,4))
xlabel('time')
ylabel('vertical velocity')
title('vertical velocity vs time')
legend('release','burn','coast','Location','north')
grid on


axes(handles.axes7)
n_release=evalin('base','n_release');
n_burn=evalin('base','n_burn');
n_coast=evalin('base','n_coast');
plot(t_release,n_release)
hold on
plot(t_burn,n_burn)
plot(t_coast,n_coast)
xlabel('time')
ylabel('load factor')
title('load factor vs time')
legend('release','burn','coast','Location','north')
grid on
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes grafici wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = grafici_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Reset.
function Reset_Callback(hObject, eventdata, handles)
% hObject    handle to Reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes1, 'reset')
cla(handles.axes2, 'reset')
cla(handles.axes3, 'reset')
cla(handles.axes4, 'reset')
cla(handles.axes5, 'reset')
cla(handles.axes6, 'reset')
cla(handles.axes7, 'reset')
guidata(hObject,handles)

% --- Executes on button press in Recalculate.
function Recalculate_Callback(hObject, eventdata, handles)
% hObject    handle to Recalculate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
grafici

% --- Executes on button press in Turnback.
function Turnback_Callback(hObject, eventdata, handles)
% hObject    handle to Turnback (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
conferma
risp=getappdata(0,'risp');
if(risp)
close(grafici)
main
end
% --- Executes on button press in Savedata.
function Savedata_Callback(hObject, eventdata, handles)
% hObject    handle to Savedata (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
stato_release=evalin('base','stato_release');
stato_burn=evalin('base','stato_burn');
stato_coast=evalin('base','stato_coast');
n_release=evalin('base','n_release');
n_burn=evalin('base','n_burn');
n_coast=evalin('base','n_coast');
load_factor=[n_release,n_burn,n_coast];

stato_tot=[stato_release;stato_burn(2:end,:);stato_coast(2:end,:)];
x=stato_tot(:,1);
y=stato_tot(:,2);
vx=stato_tot(:,3);
vy=stato_tot(:,4);
save('variables1.mat','x','y','vx','vy','load_factor')


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close(grafici)
