function varargout = grafici2(varargin)
% GRAFICI2 MATLAB code for grafici2.fig
%      GRAFICI2, by itself, creates a new GRAFICI2 or raises the existing
%      singleton*.
%
%      H = GRAFICI2 returns the handle to a new GRAFICI2 or the handle to
%      the existing singleton*.
%
%      GRAFICI2('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GRAFICI2.M with the given input arguments.
%
%      GRAFICI2('Property','Value',...) creates a new GRAFICI2 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before grafici2_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to grafici2_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help grafici2

% Last Modified by GUIDE v2.5 29-Oct-2018 16:12:46

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @grafici2_OpeningFcn, ...
                   'gui_OutputFcn',  @grafici2_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before grafici2 is made visible.
function grafici2_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to grafici2 (see VARARGIN)

% Choose default command line output for grafici2
handles.output = hObject;

set(hObject,'toolbar','figure');

stato_release=evalin('base','stato_release');
stato_burn=evalin('base','stato_burn');
stato_coast=evalin('base','stato_coast');
t_release=evalin('base','t_release');
t_burn=evalin('base','t_burn');
t_coast=evalin('base','t_coast');

[~,rho_release,~,~]=atmos(stato_release(:,2));
[~,rho_burn,~,~]=atmos(stato_burn(:,2));
[~,rho_coast,~,~]=atmos(stato_coast(:,2));
rho_release=rho_release';
rho_burn=rho_burn';
rho_coast=rho_coast';

%pressione dinamica

p_release=0.5*rho_release.*sqrt(stato_release(:,3).^2+stato_release(:,4).^2).^2;
p_burn=0.5*rho_burn.*sqrt(stato_burn(:,3).^2+stato_burn(:,4).^2).^2;
p_coast=0.5*rho_coast.*sqrt(stato_coast(:,3).^2+stato_coast(:,4).^2).^2;
assignin('base','p',[p_release;p_burn;p_coast]);

%flusso termico istantaneo modello di Sutton & Graves

r_nose=evalin('base','r_nose');
C=1.84e-4;
q_release=C*sqrt(rho_release./r_nose).*sqrt(stato_release(:,3).^2+stato_release(:,4).^2).^3;
q_burn=C*sqrt(rho_burn./r_nose).*sqrt(stato_burn(:,3).^2+stato_burn(:,4).^2).^3;
q_coast=C*sqrt(rho_coast./r_nose).*sqrt(stato_coast(:,3).^2+stato_coast(:,4).^2).^3;

%%Carico termico
%  for i=1:length(q_coast)
%     for j=1:i
%        q_load(i)=q_load(i)+q_coast(j);
%     end
%  end
[max_q,ind_maxqcoast]=max(q_coast);
v_qmax=sqrt(stato_coast(ind_maxqcoast,3)^2+stato_coast(ind_maxqcoast,4)^2);
assignin('base','v_qmax',v_qmax);

assignin('base','q',q_coast);

axes(handles.axes1)

plot(t_release,p_release)
hold on
plot(t_burn,p_burn)
plot(t_coast,p_coast)
grid on
xlabel('time')
ylabel('dynamic pressure')
legend('release','burn','coast','Location','northeast')
title('Dynamic pressure vs time')

axes(handles.axes2)

plot(t_release,q_release)
hold on
plot(t_burn,q_burn)
plot(t_coast,q_coast)
grid on
xlabel('time')
ylabel('thermal flux rate')
legend('release','burn','coast','Location','northeast')
title('Thermal flux vs time during re-entry')

axes(handles.axes3)
plot(p_release,stato_release(:,2))
hold on
plot(p_burn,stato_burn(:,2))
plot(p_coast,stato_coast(:,2))
grid on
xlabel('dynamic pressure')
ylabel('altitude')
legend('release','burn','coast','Location','northeast')
title('Dynamic pressure vs altitude')

axes(handles.axes4)
plot(q_coast,stato_coast(:,2))
grid on
xlabel('thermal flux')
ylabel('altitude')
title('Thermal flux vs altitude')

set(handles.a, 'String', num2str(evalin('base','apogee')));
set(handles.b, 'String', num2str(max_q));
set(handles.c, 'String', num2str(max(evalin('base','p'))));
set(handles.d, 'String', num2str(max([evalin('base','n_release'),evalin('base','n_burn'),evalin('base','n_coast')])));
set(handles.e, 'String', num2str(v_qmax));
set(handles.f, 'String', num2str(stato_coast(ind_maxqcoast,2)));
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes grafici2 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = grafici2_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes1, 'reset')
cla(handles.axes2, 'reset')
cla(handles.axes3, 'reset')
cla(handles.axes4, 'reset')
% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
grafici2

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
conferma
risp=getappdata(0,'risp');
if(risp)
close(grafici)
main
end

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

heat=evalin('base','q');
pressure=evalin('base','p');
save('variables2.mat','pressure','heat')
% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close(grafici2)
