function varargout = graficinew(varargin)
% GRAFICINEW MATLAB code for graficinew.fig
%      GRAFICINEW, by itself, creates a new GRAFICINEW or raises the existing
%      singleton*.
%
%      H = GRAFICINEW returns the handle to a new GRAFICINEW or the handle to
%      the existing singleton*.
%
%      GRAFICINEW('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GRAFICINEW.M with the given input arguments.
%
%      GRAFICINEW('Property','Value',...) creates a new GRAFICINEW or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before graficinew_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to graficinew_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help graficinew

% Last Modified by GUIDE v2.5 13-Mar-2019 01:11:11

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @graficinew_OpeningFcn, ...
                   'gui_OutputFcn',  @graficinew_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before graficinew is made visible.
function graficinew_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to graficinew (see VARARGIN)

% Choose default command line output for graficinew
handles.output = hObject;

set(gcf,'toolbar','figure');
set(hObject,'toolbar','figure');
stato_release=evalin('base','stato_release');
stato_burn=evalin('base','stato_burn');
stato_coast=evalin('base','stato_coast');

t_release=evalin('base','t_release');
t_burn=evalin('base','t_burn');
t_coast=evalin('base','t_coast');
t=[t_release t_burn t_coast];

[~,rho_release,~,~]=atmos(stato_release(:,2));
[~,rho_burn,~,~]=atmos(stato_burn(:,2));
[~,rho_coast,~,~]=atmos(stato_coast(:,2));
rho_release=rho_release';
rho_burn=rho_burn';
rho_coast=rho_coast';

%pressione dinamica

p_release=0.5*rho_release.*sqrt(stato_release(:,3).^2+stato_release(:,4).^2).^2;
p_burn=0.5*rho_burn.*sqrt(stato_burn(:,3).^2+stato_burn(:,4).^2).^2;
p_coast=0.5*rho_coast.*sqrt(stato_coast(:,3).^2+stato_coast(:,4).^2).^2;
assignin('base','p',[p_release;p_burn;p_coast]);

assignin('base','p_release',p_release);
assignin('base','p_burn',p_burn);
assignin('base','p_coast',p_coast);

%flusso termico istantaneo modello di Sutton & Graves

r_nose=evalin('base','r_nose');
C=1.84e-4;
q_release=C*sqrt(rho_release./r_nose).*sqrt(stato_release(:,3).^2+stato_release(:,4).^2).^3;
q_burn=C*sqrt(rho_burn./r_nose).*sqrt(stato_burn(:,3).^2+stato_burn(:,4).^2).^3;
q_coast=C*sqrt(rho_coast./r_nose).*sqrt(stato_coast(:,3).^2+stato_coast(:,4).^2).^3;

[max_q,ind_maxqcoast]=max(q_coast);
v_qmax=sqrt(stato_coast(ind_maxqcoast,3)^2+stato_coast(ind_maxqcoast,4)^2);
assignin('base','v_qmax',v_qmax);

assignin('base','q_release',q_release);
assignin('base','q_burn',q_burn);
assignin('base','q_coast',q_coast);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes graficinew wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = graficinew_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Trajectory.
function Trajectory_Callback(hObject, eventdata, handles)
% hObject    handle to Trajectory (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes1, 'reset')
axes(handles.axes1)


stato_release=evalin('base','stato_release');
stato_burn=evalin('base','stato_burn');
stato_coast=evalin('base','stato_coast');

t_release=evalin('base','t_release');
t_burn=evalin('base','t_burn');
t_coast=evalin('base','t_coast');

plot3(stato_release(:,1),zeros(length(stato_release),1),stato_release(:,2))
hold on
plot3(stato_burn(:,1),zeros(length(stato_burn),1),stato_burn(:,2))
plot3(stato_coast(:,1),zeros(length(stato_coast),1),stato_coast(:,2))
grid on
xlabel('ground track (m)')
zlabel('altitude (m)')
title('Trajectory')
stato_tot=[stato_release;stato_burn(2:end,:);stato_coast(2:end,:)]; %perch i valori iniziali sono uguali a quelli finali della fase precedente
[ymax,ind_ymax]=max(stato_tot(:,2));
assignin('base','apogee',ymax);
ymax=ymax/1000; %km
plot3(stato_tot(ind_ymax,1),0,stato_tot(ind_ymax,2),'-mo',...
    'LineWidth',1,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[.49 1 .63],...
    'MarkerSize',6)
legend('release','burn','coast','apogee','Location','northwest')
txt = ['Apogee at ' num2str(ymax) ' km'];
text(stato_tot(ind_ymax,1)+1000,0,stato_tot(ind_ymax,2),txt)


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes1, 'reset')
axes(handles.axes1)

stato_release=evalin('base','stato_release');
stato_burn=evalin('base','stato_burn');
stato_coast=evalin('base','stato_coast');

t_release=evalin('base','t_release');
t_burn=evalin('base','t_burn');
t_coast=evalin('base','t_coast');

plot(t_release,stato_release(:,1))
hold on
plot(t_burn,stato_burn(:,1))
plot(t_coast,stato_coast(:,1))
xlabel('time (s)')
ylabel('ground track (m)')
title('ground track vs time')
legend('release','burn','coast','Location','southeast')
grid on

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes1, 'reset')
axes(handles.axes1)

stato_release=evalin('base','stato_release');
stato_burn=evalin('base','stato_burn');
stato_coast=evalin('base','stato_coast');

t_release=evalin('base','t_release');
t_burn=evalin('base','t_burn');
t_coast=evalin('base','t_coast');

plot(t_release,stato_release(:,2))
hold on
plot(t_burn,stato_burn(:,2))
plot(t_coast,stato_coast(:,2))
xlabel('time (s)')
ylabel('altitude (m)')
title('altitude vs time')
legend('release','burn','coast','Location','northeast')
grid on



% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes1, 'reset')
axes(handles.axes1)

stato_release=evalin('base','stato_release');
stato_burn=evalin('base','stato_burn');
stato_coast=evalin('base','stato_coast');

t_release=evalin('base','t_release');
t_burn=evalin('base','t_burn');
t_coast=evalin('base','t_coast');

plot(t_release,sqrt(stato_release(:,3).^2+stato_release(:,4).^2))
hold on

plot(t_burn,sqrt(stato_burn(:,3).^2+stato_burn(:,4).^2))
plot(t_coast,sqrt(stato_coast(:,3).^2+stato_coast(:,4).^2))
xlabel('time')
ylabel('velocity')
title('velocity vs time')
legend('release','burn','coast','Location','north')
grid on

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes1, 'reset')
axes(handles.axes1)

stato_release=evalin('base','stato_release');
stato_burn=evalin('base','stato_burn');
stato_coast=evalin('base','stato_coast');

t_release=evalin('base','t_release');
t_burn=evalin('base','t_burn');
t_coast=evalin('base','t_coast');

plot(t_release,stato_release(:,3))
hold on

plot(t_burn,stato_burn(:,3))
plot(t_coast,stato_coast(:,3))
xlabel('time')
ylabel('horizontal velocity')
title('horizontal velocity vs time')
legend('release','burn','coast','Location','north')
grid on
% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes1, 'reset')
axes(handles.axes1)

stato_release=evalin('base','stato_release');
stato_burn=evalin('base','stato_burn');
stato_coast=evalin('base','stato_coast');

t_release=evalin('base','t_release');
t_burn=evalin('base','t_burn');
t_coast=evalin('base','t_coast');

plot(t_release,stato_release(:,4))
hold on

plot(t_burn,stato_burn(:,4))
plot(t_coast,stato_coast(:,4))
xlabel('time')
ylabel('vertical velocity')
title('vertical velocity vs time')
legend('release','burn','coast','Location','north')
grid on

% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes1, 'reset')
axes(handles.axes1)

stato_release=evalin('base','stato_release');
stato_burn=evalin('base','stato_burn');
stato_coast=evalin('base','stato_coast');

t_release=evalin('base','t_release');
t_burn=evalin('base','t_burn');
t_coast=evalin('base','t_coast');

n_release=evalin('base','n_release');
n_burn=evalin('base','n_burn');
n_coast=evalin('base','n_coast');
plot(t_release,n_release)
hold on
plot(t_burn,n_burn)
plot(t_coast,n_coast)
xlabel('time (s)')
ylabel('load factor')
title('load factor vs time')
legend('release','burn','coast','Location','north')
grid on
% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes1, 'reset')
axes(handles.axes1)

p_release=evalin('base','p_release');
p_burn=evalin('base','p_burn');
p_coast=evalin('base','p_coast');


t_release=evalin('base','t_release');
t_burn=evalin('base','t_burn');
t_coast=evalin('base','t_coast');

plot(t_release,p_release)
hold on
plot(t_burn,p_burn)
plot(t_coast,p_coast)
grid on
xlabel('time (s)')
ylabel('dynamic pressure')
legend('release','burn','coast','Location','northeast')
title('Dynamic pressure vs time')

% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes1, 'reset')
axes(handles.axes1)

q_release=evalin('base','q_release');
q_burn=evalin('base','q_burn');
q_coast=evalin('base','q_coast');

t_release=evalin('base','t_release');
t_burn=evalin('base','t_burn');
t_coast=evalin('base','t_coast');

plot(t_release,q_release)
hold on
plot(t_burn,q_burn)
plot(t_coast,q_coast)
grid on
xlabel('time')
ylabel('thermal flux rate')
legend('release','burn','coast','Location','northeast')
title('Thermal flux vs time during re-entry')


% --- Executes during object creation, after setting all properties.
function Trajectory_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Trajectory (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
