function [stato,n]=orb_release(stato_in,t_in,t_fin,dt)

%funzione che calcola la traiettoria della fase di rilascio
%prende in input i dati iniziali
%la fase di rilascio dura "release_dur" secondi, met dei quali
%caratterizzati da una caduta libera, mentre l'altra met da una manovra
%flare dove il velivolo raggiunge un angolo di 10 "angle_fin"



t=t_in:dt:t_fin;

l1=length(stato_in);
l2=length(t);
stato=zeros(l2,l1);
stato(1,:)=stato_in;
n=zeros(1,l2);
for i=1:l2-1
    
    
    [p1,n(i)]=orb_dyn_release(stato(i,:));
    p2=orb_dyn_release(stato(i,:)+dt*p1/2);
    p3=orb_dyn_release(stato(i,:)+dt*p2/2);
    p4=orb_dyn_release(stato(i,:)+dt*p3);
    
    stato(i+1,:)=stato(i,:)+dt*(p1/6+p2/3+p3/3+p4/6);
    
end

end